unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, system.UITypes,
  Dialogs, ExtCtrls, ocv.core_c, ocv.core.types_c, ocv.compat, ocv.highgui_c,
  ocv.haar, ocv.legacy, ocv.objdetect_c,ocv.imgproc_c, ocv.imgproc.types_c;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    Capture: PCvCapture;
    CameraBmp: TBitmap;
    Storage: PCvMemStorage;
    Xml: ansistring;
    Cascade2: PCvHaarClassifierCascade;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  fgray     : PIplImage;
  fFormset  : Boolean;

const
// JdlɈˑ܂
  VideoWidth = 1280;
  VideoHeight = 960;

{-----------------------------------------------------------------------------
  Procedure:  IplImageToBitmap
  Date:       28-Feb-2017
  Arguments:  iplImg: PIplImage; bitmap: TBitmap
  Description: convert a IplImage to a Windows bitmap
-----------------------------------------------------------------------------}
procedure IplImageToBitmap(iplImg: PIplImage; var bitmap: TBitmap);
var
  j: integer;
  offset: integer;
  dataByte: PByte;
  RowIn: PByte;
begin
  try
    // data 8bit BGR 3byte color ̊mF
    assert((iplImg.Depth = 8) and (iplImg.NChannels = 3),
            'IplImageToBitmap: Not a 24 bit color iplImage!');

    bitmap.Height := iplImg.Height;
    bitmap.Width := iplImg.Width;
    // [̉摜̏㉺Ăꍇ
    if (iplImg.ChannelSeq = 'BGR') and (iplimg.Origin = IPL_ORIGIN_BL) then begin
      RowIn := Bitmap.Scanline[bitmap.height - 1];
      dataByte := pbyte(iplimg.ImageData);
      {direct copy of the iplImage row bytes to bitmap row}
      CopyMemory(rowin, dataByte, iplImg.ImageSize);
      exit;
    end
    // [̉摜̏㉺ĂȂꍇ
    else begin
      for j := 0 to Bitmap.Height - 1 do begin
        RowIn := Bitmap.Scanline[j];
        offset := integer(iplimg.ImageData) + iplImg.WidthStep * j;
        dataByte := pbyte(offset);
        CopyMemory(rowin, dataByte, iplImg.WidthStep);
      end;
    end;
  except
    on E: Exception do begin
      Form1.Timer1.Enabled := False;
      MessageDlg('IplImageToBitmap failed - ' + e.Message, mtError, [mbOK], 0);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fFormset := False;
  fgray := nil;

  Form1.Top := (Screen.Height - Form1.Height) div 2;
  Form1.Left := (Screen.Width - Form1.Width) div 2;

  // cvCreateCameraCaptureindex̓J̔ԍݒ肵Ă
  Capture := cvCreateCameraCapture(0);
  if not Assigned(Capture) then begin
    MessageDlg('JG[', mtError, [mbOK], 0);
    Exit;
  end;
  cvSetCaptureProperty(Capture, CV_CAP_PROP_FRAME_HEIGHT, VideoHeight);
  cvSetCaptureProperty(Capture, CV_CAP_PROP_FRAME_WIDTH, VideoWidth);

  // _uobt@łh~
  DoubleBuffered := True;

  //R|[lg\p̃rbg}bv
  CameraBmp := TBitmap.Create;
  CameraBmp.PixelFormat := pf24bit;
	Storage := cvCreateMemStorage(0);
	Xml := 'haarcascade_frontalface_alt.xml';
//	Xml := 'haarcascade_frontalface_default.xml';  // default
	Cascade2 := PCvHaarClassifierCascade(cvLoad(PAnsiChar(Xml), nil, nil, nil));

  // ftHg̕ύXvpeB
  with Image1 do begin
    Align := alClient;
    Center := True;
    Proportional := True;
    Stretch := True;
  end;
  Timer1.Interval := 20;
  Timer1.Enabled := True;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  cvReleaseCapture(Capture);
  FreeAndNil(CameraBmp);
  cvReleaseImage(fgray);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  frame: PIplImage;
  r: PCvRect;
	faces: PCvSeq;
  i: Integer;
	pt1, pt2: TCvPoint2D32f;
begin
  // 摜̎擾
  frame  := cvQueryFrame(Capture);
  if not Assigned(frame) then Exit;
  // \TCYݒ
  if not fFormset then begin
    Form1.ClientHeight := frame.height div 2;
    Form1.ClientWidth := frame.width div 2;
    Form1.Top := (Screen.Height - Form1.Height) div 2;
    Form1.Left := (Screen.Width - Form1.Width) div 2;
    fFormset := true;
  end;
  // O[p[m
  if fgray = nil then
    fgray := cvCreateImage(cvGetSize(frame), IPL_DEPTH_8U, 1);
  // J[O[ϊ
  cvCvtColor(frame, fgray, CV_BGR2GRAY);
  // O[qXgO
  cvEqualizeHist(fgray, fgray);

  // Xg[WNA
	cvClearMemStorage(Storage);
  // 摜畨̌o
	faces := cvHaarDetectObjects(
		fgray, Cascade2, Storage, 1.2, 3,
      CV_HAAR_DO_CANNY_PRUNING, CvSize(50, 50), CvSize(0, 0));
{
	faces := cvHaarDetectObjects(
		frame, Cascade2, Storage, 1.2, 4,
      CV_HAAR_DO_CANNY_PRUNING, CvSize(50, 50), CvSize(720, 720));
}
  // OpenCV -> delphi bitmap
  IplImageToBitmap(frame, CameraBmp);
  // 畔Ԙg
	CameraBmp.Canvas.Pen.Color	:= clRed;
	CameraBmp.Canvas.Pen.Width	:= 3;
	CameraBmp.Canvas.Brush.Style:= bsClear;
	for i := 0 to faces.total - 1 do begin
		r		:= PCvRect(cvGetSeqElem(Faces, i));
		pt1.x	:= r.x;
		pt2.x	:= r.x + r.width;
		pt1.y	:= r.y;
		pt2.y	:= r.y + r.height;
    // ``
		CameraBmp.Canvas.Rectangle(Round(pt1.x),
      Round(pt1.y), Round(pt2.x), Round(pt2.y));
	end;

  Image1.Canvas.StretchDraw(Image1.Canvas.ClipRect, CameraBmp);
end;

end.
